/* $Id$ */
/* ARC BIOS memory dectection

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <asm/addrspace.h>
#include <stdio.h>
#include <arc/arc.h>
#include <arc/memory.h>
#include <arc/proto.h>

/*
 * Find out how much memory is installed via the ARC BIOS.
 */
unsigned long
arc_mem_detect (void)
{
  PMEMORY_DESCRIPTOR memdesc = NULL;
  unsigned long memtop = 0;

  do
    {
      unsigned long base, end, size;

      memdesc = GetMemoryDescriptor (memdesc);
      if (memdesc == NULL)
	break;

      /*
       * The SNI BIOS implementation returns pagenumbers for both KSEG0 and
       * KSEG1, so we make shure and convert them into physical addresses
       * again.
       */
      base = PHYSADDR (memdesc->BasePage << 12);
      size = memdesc->PageCount << 12;
      end = base + size;

      if (end > memtop)
	memtop = end;
    }
  while (memdesc);

  return memtop;
}
