/* $Id: arc.h,v 1.4 1996/02/06 01:10:10 seb Exp $ */
/* ARC BIOS interface routines

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifndef __ARC_H
#define __ARC_H

/*
 * exit codes
 */
#define EXIT_FAILURE    1	/* Failing exit status.  */
#define EXIT_SUCCESS    0	/* Successful exit status.  */

typedef struct DisplayInfo	/* video adapter information */
  {
    unsigned short cursor_x;
    unsigned short cursor_y;
    unsigned short columns;
    unsigned short lines;
  }
DisplayInfo;

char *getVendorId (void);	/* get vendor id */
char *getProductId (void);	/* get product id */
char *getSystemId (void);	/* get system id (might be different from */
				/* above) */
unsigned long arc_mem_detect (void);	/* return the memory amount according */
				    /* to ARC BIOS */

/*
 * CPU Info
 */
char *getCpuType (void);	/* get cpu type */
unsigned int getCpuId (void);	/* get cpu id (might be different from above) */
char *getFpuType (void);	/* get fpu id */

/*
 * Cache Size Info
 */
#define SIZE_UNKNOWN   0xffffffff

unsigned int getPrimaryICacheSize (void);	/* get primary ICache size */
unsigned int getPrimaryDCacheSize (void);	/* get primary DCache size */
unsigned int getSecondaryICacheSize (void);	/* get secondary ICache size */
unsigned int getSecondaryDCacheSize (void);	/* get secondary DCache size */
unsigned int getSecondaryCacheSize (void);	/* get secondary DCache size */

/*
 * Diplay Info
 */
DisplayInfo *getDisplayInfo (void);	/* get display info */

/*
 * The following variables are used to control workarounds for ARC
 * BIOS bugs and are of course not part of the ARC standard...
 */
extern int __hw_type;		/* hardware type                */
extern int __splitted_rw;	/* do r/w in 512 byte chunks    */

#endif /* __ARC_H */
