/* $Id: errno.h,v 1.4 1996/02/06 01:10:11 seb Exp $ */
/* ARC BIOS errno

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifndef __ERROR_H
#define __ERROR_H

typedef enum STATUS
  {
    ESUCCESS,			/* Success                   */
    E2BIG,			/* Arg list too long         */
    EACCES,			/* No such file or directory */
    EAGAIN,			/* Try again                 */
    EBADF,			/* Bad file number           */
    EBUSY,			/* Device or resource busy   */
    EFAULT,			/* Bad address               */
    EINVAL,			/* Invalid argument          */
    EIO,			/* I/O error                 */
    EISDIR,			/* Is a directory            */
    EMFILE,			/* Too many open files       */
    EMLINK,			/* Too many links            */
    ENAMETOOLONG,		/* File name too long        */
    ENODEV,			/* No such device            */
    ENOENT,			/* No such file or directory */
    ENOEXEC,			/* Exec format error         */
    ENOMEM,			/* Out of memory             */
    ENOSPC,			/* No space left on device   */
    ENOTDIR,			/* Not a directory           */
    ENOTTY,			/* Not a typewriter          */
    ENXIO,			/* No such device or address */
    EROFS,			/* Read-only file system     */
  }
_STATUS;

/*
 * Don't use the errno from <errno.h> since we would run
 * into trouble with the other definitions from that file
 */
extern int errno;

#endif /* __ERRNO_H */
