/* $Id: memory.h,v 1.4 1996/02/06 01:10:11 seb Exp $ */
/* ARC BIOS memory related definitions

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifndef __MEMORY_H
#define __MEMORY_H

typedef enum _MEMORY_TYPE
  {
    MemoryExceptionBlock,
    MemorySystemBlock,
    MemoryFree,
    MemoryBad,
    MemoryLoadedProgram,
    MemoryFirmwareTemporary,
    MemoryFirmwarePermanent,
    MemoryFreeContiguous,
    MemorySpecialMemory
  }
MEMORY_TYPE;

typedef struct _MEMORY_DESCRIPTOR
  {
    MEMORY_TYPE MemoryType;
    ULONG BasePage;
    ULONG PageCount;
  }
MEMORY_DESCRIPTOR, *PMEMORY_DESCRIPTOR;

/*
 * ARC BIOS uses 4k pagesize only
 */
#define PAGE_SHIFT 12
#define PAGESIZE   4096

#endif /* __MEMORY_H */
