/* $Id: types.h,v 1.4 1996/02/06 01:10:13 seb Exp $ */
/* ARC BIOS types definitions

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifndef __TYPES_H
#define __TYPES_H

/*
 * Typedefinitions for bootloader.
 */
typedef signed char CHAR;
typedef signed short SHORT;
typedef signed long long LARGE_INTEGER;
typedef signed int LONG;
typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef unsigned int ULONG;
typedef unsigned short WCHAR;
typedef void VOID;

/*
 * The corresponding pointer types
 */
typedef CHAR *PCHAR;
typedef SHORT *PSHORT;
typedef LARGE_INTEGER *PLARGE_INTEGER;
typedef LONG *PLONG;
typedef UCHAR *PUCHAR;
typedef USHORT *PUSHORT;
typedef ULONG *PULONG;
typedef WCHAR *PWCHAR;
typedef VOID *PVOID;
typedef void *PHYSICAL_ADDRESS;

/*
 * Signal() handler stuff
 */
typedef VOID (*SIGNALHANDLER) (ULONG);

/*
 * The usual stuff...
 */
#ifndef NULL
#define NULL (void *)0L
#endif

#endif /* __TYPES_H */
