/* $Id: mallocinit.c,v 1.4 1996/02/06 01:10:34 seb Exp $ */
/* btn (better than nothing) malloc(3)

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <arc/proto.h>
#include <arc/malloc.h>
#include <asm/addrspace.h>

extern int _end;
extern int loadaddr;

struct mpool *_FirstChunk = NULL;
static inline int 
checkchunk (PMEMORY_DESCRIPTOR d)
{
  PVOID addr;

  addr = (PVOID) (d->BasePage << PAGE_SHIFT);

  /*
   * This function is a bugfix for the Deskstation Tyne ARC BIOS
   * which returns an memory descriptor for address
   * 0x84000000, size 0x400000. Maybe it's a BIOS bug in 1.3.017,
   * maybe it's just because I've got only 8mb installed which
   * conflicts with the specification.
   */

  if (addr == (PVOID) 0x04000000)
    return 0;
  if (d->MemoryType != MemoryFree)
    return 0;

  /*
   * Seems to be legal.
   */

  return 1;
}

void 
initmalloc (void)
{
  PMEMORY_DESCRIPTOR d = NULL;
  ULONG p, size, chunkend;

  while ((d = GetMemoryDescriptor (d)))
    {
      /*
       * Add free RAM to list, do as if RAM is mapped to ksegx
       */

      if (checkchunk (d))
	{
	  p = (d->BasePage << PAGE_SHIFT) | KSEGX (loadaddr);
	  size = d->PageCount << PAGE_SHIFT;
	  if (p >= loadaddr && p < (ULONG) & _end)
	    {
	      chunkend = p + size;
	      p = ((ULONG) & _end) + (PAGESIZE - 1);
	      p = p & ~(PAGESIZE - 1);
	      size = chunkend - p;
	    }
	  ((struct mpool *) p)->NextChunk = _FirstChunk;
	  ((struct mpool *) p)->Size = size;
	  _FirstChunk = (struct mpool *) p;
	}
    }
}
