/* $Id: putenv.c,v 1.4 1996/02/06 01:10:35 seb Exp $ */
/* ARC BIOS putenv routine

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <arc/proto.h>
#include <string.h>

int 
putenv (const char *string)
{
  CHAR name[1024];
  _STATUS st;
  PCHAR index;

  strncpy (name, string, 1024);
  index = memscan (name, '=', 1022);
  if (index == NULL)
    {
      errno = EINVAL;
      return -1;
    }
  *index = '\0';
  st = SetEnvironmentVariable (name, index + 1);
  if (st != ESUCCESS)
    {
      errno = st;
      return -1;
    }

  return 0;
}
