/* $Id: seek.c,v 1.4 1996/02/06 01:10:36 seb Exp $ */
/* ARC BIOS seek routine

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <arc/proto.h>
#include <stdio.h>
#include <unistd.h>

off_t
lseek (int fd, off_t offset, int whence)
{
  LARGE_INTEGER off;
  _STATUS st;
  FILE_INFORMATION fi;

  off = offset;
  switch (whence)
    {
    case L_SET:
      st = Seek ((ULONG) fd, &off, (SEEK_MODE) SeekAbsolute);
      if (st != ESUCCESS)
	{
	  errno = st;
	  return -1;
	}
      break;
    case L_INCR:
      st = Seek ((ULONG) fd, &off, (SEEK_MODE) SeekRelative);
      if (st != ESUCCESS)
	{
	  errno = st;
	  return -1;
	}
      break;
    case L_XTND:
      st = GetFileInformation (fd, &fi);
      if (st != ESUCCESS)
	{
	  errno = st;
	  return -1;
	}
      return (off_t) fi.EndingAddress;
      break;
    default:
      errno = EINVAL;
      return -1;
    }
  st = GetFileInformation (fd, &fi);
  if (st != ESUCCESS)
    {
      errno = st;
      return -1;
    }

  return (off_t) fi.CurrentPosition;
}
