/* $Id: __main.c,v 1.4 1996/02/06 01:10:24 seb Exp $ */
/* C startup code
   Copyright 1995 by Ralf Baechle

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <debug.h>
#include <stdio.h>
#include <string.h>
#include <asm/bootinfo.h>
#include <arc/arc.h>

int __hw_type;
int __splitted_rw;

_IO_FILE __FILE[FOPEN_MAX];

void 
__main (void)
{
  char *SystemID;
  int i;

  /*
   * Detect hardware type
   */
  SystemID = getSystemId ();
  if (debuglevel >= 2)
    printf ("SystemID = %s\r\n", SystemID);

  if (!strcmp (SystemID, "PICA-61"))
    __hw_type = MACH_ACER_PICA_61;
  else if (!strcmp (SystemID, "DESKTECH-ARCStation I"))
    __hw_type = MACH_DESKSTATION_RPC44;
  else if (!strcmp (SystemID, "DESKTECH-TYNE"))
    __hw_type = MACH_DESKSTATION_TYNE;
  else if (!strcmp (SystemID, "RM200PCI"))
    __hw_type = MACH_SNI_RM200_PCI;
  else if (!strcmp (SystemID, "Microsoft-Jazz"))
    {
      __hw_type = MACH_MIPS_MAGNUM_4000;	/* here it also means Olivetti */
      __splitted_rw = 1;
    }
  else
    {
      __hw_type = MACH_UNKNOWN;
      /*
       * By default we assume the ARC BIOS to be broken. This
       * is dogslow but has somewhat better chances to work...
       */
      __splitted_rw = 1;
    }

  /*
   * Init standard library file handling
   */
  __FILE[0].fh = 0;
  __FILE[1].fh = 1;
  __FILE[2].fh = 1;
  for (i = 3; i < FOPEN_MAX; i++)
    __FILE[i].fh = -1;
}
