/* $Id: errlist.c,v 1.4 1996/02/06 01:10:29 seb Exp $ */
/* Error messages

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <ansidecl.h>
#include <stddef.h>

/*
 * This is a list of all known error numbers.
 */
CONST char *CONST _sys_errlist[] =
{
  "Unknown error",		/* ESUCESS */
  "Arg list too long",		/* E2BIG */
  "Permission denied",		/* EACCES */
  "Try again",			/* EAGAIN */
  "Bad file number",		/* EBADF */
  "Device or resource busy",	/* EBUSY */
  "Bad address",		/* EFAULT */
  "Invalid argument",		/* EINVAL */
  "I/O error",			/* EIO */
  "Is a directory",		/* EISDIR */
  "Too many open files",	/* EMFILE */
  "Too many links",		/* EMLINK */
  "File name too long",		/* ENAMETOOLONG */
  "No such device",		/* ENODEV */
  "No such file or directory",	/* ENOENT */
  "Exec format error",		/* ENOEXEC */
  "Out of memory",		/* ENOMEM */
  "No space left on device",	/* ENOSPC */
  "Not a directory",		/* ENOTDIR */
  "Not a typewriter",		/* ENOTTY */
  "No such device or address",	/* ENXIO */
  "Read-only file system",	/* EROFS */
  NULL
};


#define NR_ERRORS ((sizeof (_sys_errlist))/(sizeof(char *))-1)

CONST int _sys_nerr = NR_ERRORS;
