/* $Id: fopen.c,v 1.4 1996/02/06 01:10:31 seb Exp $ */
/* fopen emulation
   Copyright (C) 1995 by Ralf Baechle

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <arc/errno.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

/*
 * Prototypes
 */
extern FILE *__sflags (const char *mode, int *flags);
extern FILE *__sfp ();

FILE *
fopen (const char *file, const char *mode)
{
  FILE *nfp;
  int f;
  int flags;

  if (mode == NULL)
    return NULL;
  if (__sflags (mode, &flags) == 0)
    return NULL;
  if ((nfp = __sfp ()) == NULL)
    return NULL;
  if ((f = open (file, flags, DEFFILEMODE)) < 0)
    return NULL;
  nfp->fh = f;
  /*
   * Seek to the end of file when opening in append mode.
   */
  if (flags & O_APPEND)
    lseek (nfp->fh, (off_t) 0, SEEK_END);

  return nfp;
}
