/* $Id: unistd.h,v 1.2 1996/03/17 16:52:02 seb Exp $ */
/* fake unistd.h
   Copyright (c) 1996 M Warner Losh

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifndef __UNISTD_H
#define __UNISTD_H

#include <linux/types.h>
#include <arc/types.h>

/* whence values for lseek(2) */
#define	SEEK_SET	0	/* set file offset to offset */
#define	SEEK_CUR	1	/* set file offset to current plus offset */
#define	SEEK_END	2	/* set file offset to EOF plus offset */

#ifndef _POSIX_SOURCE
/* whence values for lseek(2); renamed by POSIX 1003.1 */
#define	L_SET		SEEK_SET
#define	L_INCR		SEEK_CUR
#define	L_XTND		SEEK_END
#endif

#define __ptr_t void*

ssize_t write (int fd, const __ptr_t buf, size_t count);
ssize_t read (int fd, __ptr_t buf, size_t count);
off_t lseek (int fd, off_t offset, int whence);
int close (int fd);
u_int sleep (u_int);

extern char *optarg;
extern int optind;
extern int optopt;
extern int opterr;
extern int optreset;

int getopt (int, char *const *, const char *);


#endif /* !__UNISTD_H */
