/* $Id: acer_pica_61.c,v 1.4 1996/02/06 01:10:02 seb Exp $ */
/* ACER pica 61 support routines

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <asm/addrspace.h>
#include <asm/pica.h>
#include <asm/bootinfo.h>

#include <milo.h>
#include <stdio.h>

typedef struct
  {
    char *name;
    unsigned int size;		/* Size of a four SIMM bank in bytes */
  }
simm_type;

#define MB (1024*1024)
static simm_type simm_types[] =
{
  {"4 * 256K*36 SIMM", 4 * MB},
  {"4 * 512K*36 SIMM", 8 * MB},
  {"4 * 1M*36 SIMM", 16 * MB},
  {"4 * 2M*36 SIMM", 32 * MB},
  {"4 * 4M*36 SIMM", 64 * MB},
  {"4 * 8M*36 SIMM", 128 * MB},
  {"(This should not happen)", 0},
  {"No SIMM", 0}
};

static unsigned long 
acer_pica_61_mem (void)
{
  unsigned long ram;
  volatile dram_configuration *dc;

  dc = (dram_configuration *) PICA_DRAM_CONFIG;
  if (debuglevel >= 2)
    {
      printf ("RAM bank %s             : %s\r\n",
	      (dc->mem_bus_width ? "A1" : "A "), simm_types[dc->bank1].name);
      printf ("RAM bank %s             : %s\r\n",
	      (dc->mem_bus_width ? "A2" : "B "), simm_types[dc->bank2].name);
    }
  ram = simm_types[dc->bank1].size + simm_types[dc->bank2].size;
  return ram;
}

int 
acer_pica_61_bi (void)
{
  memory_upper = KSEGX (KERNELBASE) | acer_pica_61_mem ();
  /* we don't need to create a memupper tag. but for consistency... */
  bi_TagAdd (tag_memupper, ULONGSIZE, (void *) &memory_upper);
  return 0;
}
