/* $Id$ */
/* display ARC BIOS idea of memory layout

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <stdio.h>
#include <arc/arc.h>
#include <arc/memory.h>
#include <arc/proto.h>

static char *typenames[] =
{
  "ExceptionBlock",
  "SystemParameterBlock",
  "FreeMemory",
  "BadMemory",
  "LoadedProgram",
  "FirmwareTemporary",
  "FirmwarePermanent"
};

/*
 * memory()
 * Show the memorylist of the ARC BIOS.
 */
int
memory (int argc, char *argv[])
{
  PMEMORY_DESCRIPTOR memdesc = NULL;
  int i = 0;

  printf ("#    start    - end       size     type\r\n\r\n");
  do
    {
      unsigned long base, end, size;
      char *typename;

      memdesc = GetMemoryDescriptor (memdesc);
      if (memdesc == NULL)
	break;

      base = 0x80000000 | (memdesc->BasePage << 12);
      size = memdesc->PageCount << 12;
      end = base + size;
      typename = typenames[memdesc->MemoryType];
      printf ("%3d: %08lx - %08lx  %08lx %s\r\n", i, base, end, size, typename);
      i++;
    }
  while (memdesc);

  return 0;
}
