/* $Id: dskst_tyne.c,v 1.5 1996/02/06 01:10:03 seb Exp $ */
/* Deskstation Tyne support routines

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <linux/tty.h>
#include <asm/io.h>
#include <asm/bootinfo.h>
#include <stdio.h>
#include <milo.h>

/*
 * deskstation_tyne_init()
 */
int 
deskstation_tyne_init (void)
{
  /*
   * Grr... The ARC BIOS doesn't setup the hardware like
   * a Intel PC BIOS would do...
   */
  outb_p (0x6, 0x3ce);
  outb_p (0xe, 0x3cf);

  return 0;
}

/*
 * deskstation_tyne_bi()
 */
int 
deskstation_tyne_bi (void)
{
  struct screen_info si = DEFAULT_SCREEN_INFO;

  /* FIXME: This is a hack for Tyne boards. Unfortunally
   * we cannot execute the VGA card bios, so we hardcode
   * some variables here... Will change later.
   */

  si.orig_x = 0;
  si.orig_y = 0;
  si.orig_video_page = 52;
  si.orig_video_mode = 3;
  si.orig_video_cols = 80;
  si.orig_video_ega_bx = 3;
  si.orig_video_lines = 50;
  bi_TagAdd (tag_screen_info, sizeof (struct screen_info), (void *) &si);

  return 0;
}

/*
 * deskstation_rpc44_bi
 *
 */
int 
deskstation_rpc44_bi (void)
{
  /* XXX IMP fixme-- Figure out how to get the memory of this beast */
  memory_upper = KSEG0 + (32 << 20);
  /* we don't need to create a memupper tag. but for consistency... */
  bi_TagAdd (tag_memupper, ULONGSIZE, (void *) &memory_upper);
  if (debuglevel >= 1)
    printf ("Found a Deskstation RPC44, assuming 32M of memory\r\n");
  return 1;
}
