/*
 * g364.c
 * G364 video adapter functions
 *
 * Copyright (C) 1995 by Luc Beurton <Luc.Beurton@fnet.fr>
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License. See the file COPYING in the main directory of this archive for more
 * details.
 */
#include <g364.h>

unsigned int G364_Table[2][7]={
/*	{0x12,0x20,0x100,0x5b,0x36,0x600,0x14a},*/
	{0x19,0x22,0x100,0x4e,0x46,0x600,0x164},
	{0x1a,0x28,0x140,0x6b,0x46,0x800,0x1aa}
};

/*--- Control Registers A ---*/
int G364_SWITCHOFF_VTG(void)
{
	*(volatile unsigned int *)G364_CTRL_A &= 0xFFFFFFFE;

	return 0;
}

int G364_SWITCHON_VTG(void)
{
	*(volatile unsigned int *)G364_CTRL_A |= 0x1;

	return 0;
}

int G364_TOPOFSCREEN(unsigned int top)
{
	*(volatile unsigned int*)G364_TopOfScreen = top;

	return  0;
}

int G364_Reset(void)
{
	*(unsigned int*)G364_RESET = 1;

	return 0;
}

/*--- Screen Description Parameters ---*/

int G364_get_display(unsigned int *x,unsigned int *y)
{
	G364_SWITCHOFF_VTG();
	*x = (*((volatile unsigned int*)G364_Display) & 0x00ffffff) * 4;
	*y = (*((volatile unsigned int*)G364_VDisplay) & 0x00ffffff) / 2;
	G364_SWITCHON_VTG();
	G364_TOPOFSCREEN(0);

	return 0;
}

int G364_set_display(int tab)
{
	G364_SWITCHOFF_VTG();
	*(volatile unsigned int*)G364_Half_Sync     = G364_Table[tab][0];
	*(volatile unsigned int*)G364_Back_Porch    = G364_Table[tab][1];
	*(volatile unsigned int*)G364_Display       = G364_Table[tab][2];
	*(volatile unsigned int*)G364_Short_Display = G364_Table[tab][3];
	*(volatile unsigned int*)G364_VBlank        = G364_Table[tab][4];
	*(volatile unsigned int*)G364_VDisplay      = G364_Table[tab][5];
	*(volatile unsigned int*)G364_LineTime      = G364_Table[tab][6];
	G364_SWITCHON_VTG();

	return 0;
}
