/* $Id$ */
/* definitions and prototypes for Pandora 

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifndef __PANDORA_H
#define __PANDORA_H

/*
 * Command strings
 */
#define CMD_BOOT       "boot"
#define CMD_DUMP       "dump"
#define CMD_DUMPTLB    "dumptlb"
#define CMD_FILL       "fill"
#define CMD_MEMORY     "memory"
#define CMD_PROBE      "probe"
#define CMD_HELP       "help"
#define CMD_NOP        "nop"
#define CMD_QUIT       "quit"
#define CMD_STRINGS    "strings"
#define CMD_CP0REGS    "cp0regs"
#define CMD_DISASM     "disasm"

#define FALSE             0
#define TRUE              1

#define MAXBUFLEN         256

#define SW_BYTE           1
#define SW_HALFWORD       2
#define SW_WORD           4

/*
 * Prototypes
 */
int pandora_boot (int argc, char **argv);
int dump (int argc, char **argv);
int dumptlb (int argc, char **argv);
int fill (int argc, char **argv);
int memory (int argc, char **argv);
int probe (int argc, char **argv);
int strings (int argc, char **argv);
int cp0regs (void);
int dump_cp0r (void);
int quit (int argc, char *argv[]);
int disasm (int argc, char *argv[]);
int pandora (void);

#endif /* __PANDORA_H */
